# -*- coding: utf-8 -*-
#erbnva_globalPlugin/__init__.py
#A part of the eurobraille driver for NVDA (Non Visual Desktop Access)

import datetime
import gettext
import os.path
import shutil
import time
import webbrowser
import subprocess
from subprocess import *
import configobj
import wx
import addonHandler
addonHandler.initTranslation()
import core
import globalVars
import globalPluginHandler
import gui
import languageHandler
from logHandler import log
import speech
import config
from dialogs import *


aboutMessage =_(u"""
 URL: {url}
 NVDA eurobraille driver and configuration utility: v 17.06.01 (19/06/2017).
Company: Eurobraille sas.
Author:  Didier Poitou.
 
This component was developed by Eurobraille, with contributions from many others. Special thanks goes to:
{contributors}
""")

contributors = u"Nvda-fr.org, Michel Such."

URL = "http://www.eurobraille.com"

class GlobalPlugin(globalPluginHandler.GlobalPlugin):
	def __init__(self):
		super(GlobalPlugin, self).__init__()
		if globalVars.appArgs.secure:
			return
		self.createMenu()

	def createMenu(self):
		self.submenu_erbnvda = wx.Menu()
		
		item = self.submenu_erbnvda.Append(wx.ID_ANY, _("Configuration..."), _("Open the eurobraille driver configuration."))
		gui.mainFrame.sysTrayIcon.Bind(wx.EVT_MENU , lambda e : gui.mainFrame._popupSettingsDialog(ErbNvdaSettingsDialog), item)
		item = self.submenu_erbnvda.Append(wx.ID_ANY, _("About Eurobraille Driver for NVDA"))
		gui.mainFrame.sysTrayIcon.Bind(wx.EVT_MENU , self.onAbout, item)
		self.submenu_item = gui.mainFrame.sysTrayIcon.menu.InsertMenu(2, wx.ID_ANY, _("Eurobraille driver"), self.submenu_erbnvda)

	def removeMenu(self):
		if self.submenu_item is not None:
			try:
				gui.mainFrame.sysTrayIcon.menu.RemoveItem(self.submenu_item)
			except AttributeError: # We can get this somehow from wx python when NVDA is shuttingdown, just ignore
				pass

	def onAbout(self, event):
#		wx.CallLater(2000, gui.messageBox,
#		_("The Eurobraille driver supports Esytime, Esys and Iris devices.\n"
#		"Version 12.11.2 (22/11/2012)\n"),
#		caption=_("Eurobraille driver information."))
		msg = aboutMessage.format(url=URL, contributors=contributors, **locals())
		gui.messageBox(msg, _("About Eurobraille driver for NVDA"), wx.OK)

	def  terminate(self):
		try:
			self.removeMenu()
		except wx.PyDeadObjectError:
			pass
